#include "PointKDTree.hpp"

PointKDTree::Node::~Node()
{
  delete lo;
  delete hi;
}

PointKDTree::PointKDTree(std::vector<Point> const & points)
: root(NULL)
{
  static size_t const MAX_POINTS_PER_LEAF = 5;

  // A kd-tree is just a binary search tree, and is constructed in a near-identical way.
  //
  // - Initially assign (pointers to) all points to the root node.
  // - Recursively subdivide the points, splitting the parent box in half along the longest axis and creating two child nodes
  //   for each split. Stop when number of points in node <= MAX_POINTS_PER_LEAF.
  // - Don't forget to save space by clearing the arrays of points in internal nodes. Only the leaves need to store references
  //   to points.
}

void
PointKDTree::rangeQuery(AxisAlignedBox3 const & query, std::vector<Point *> & points_in_range) const
{
  points_in_range.clear();

  // Write a helper function rangeQuery(node, query, points_in_range):
  //   - If node->bbox does not intersect query, return
  //   - If node->lo && node->lo->bbox intersects query, rangeQuery(node->lo, query, points_in_range)
  //   - If node->hi && node->hi->bbox intersects query, rangeQuery(node->hi, query, points_in_range)
}
